#include <iostream>
#include <iomanip>
#include <sstream>
#include <string>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <list>
#include <set>
#include <algorithm>
#include <utility>
#include <functional>
#include <numeric>
#include <cassert>
#include <cmath>
#include <string>
#include <cctype>
#include <cstdio>
#include <cstdlib>

using namespace std;

#define DEBUGGING 1

#if defined(DEBUGGING)
#define debug(...) fprintf(stderr,__VA_ARGS__)
#else
#define debug(...)
#endif

int main()
{
	int n;
	cin >> n;

	if ( n%2 ) {
		cout << "impossible" << endl;
		return 0;
	}
	int n2 = n/2;

	map<pair<long long,long long>,int> skills;
	long long B = 0, P = 0;
	for(long long i=0; i<n; i++) {
		long long b,p;
		cin >> b >> p;
		pair<long long,long long> skill(b,p);
		skills[skill]++;
		B += b;
		P += p;
	}

	if ( B%n2 || P%n2 ) {
		cout << "impossible" << endl;
		return 0;
	}
	B /= n2;
	P /= n2;

	bool ok = true;
	for(auto it : skills) {
		pair<long long,long long> skill = it.first;
		pair<long long,long long> join(B-skill.first,P-skill.second);
		if ( skills[join]!=it.second ) ok = false;
	}

	if ( ok ) {
		cout << "possible" << endl;
	} else {
		cout << "impossible" << endl;
	}

	return 0;
}
